# zbot/plugs/list.py
#
#

## IMPORTS


from zbot.utils import error, time_string, to_time, time_stamp, do_objects, format_obj, short_date
from zbot import kernel

## basic imports

import threading
import logging
import re

# commands function

def do_list(event):
    if not event.rest: event.reply(" ".join(kernel.keys())) ; return
    name = event.args[1]
    opts = event.opts
    args = event.args
    knobs = event.knobs
    if "mdate" not in args: args.insert(0, "mdate")
    else: args.extend(list(opts.keys()))
    done = []
    objs = []
    for obj in do_objects(event):
        try:
            obj.mdate = short_date(obj.Date)
            if not obj.mdate: obj.mdate = to_time(obj.added)
        except: error()
        value = None
        go = True
        for arg in args:
            try: value = getattr(obj, arg)
            except AttributeError: continue
            if not value: continue
        if go: objs.append(obj)
    for obj in sorted(objs, key=lambda x: x.mdate):
        txt = ""
        for arg in args:
            try: txt += "%s -=- " % obj[arg]
            except KeyError: continue
        if not txt: continue
        txt = txt[:-5]
        if "text" in opts:
            for line in obj.text.splitlines():
                if opts["text"] in line: event.reply("%s -=- %s" % (txt, line)) ; break
        else: event.reply(txt)        
        if "u" in knobs:
            if txt not in done: done.append(txt)
        else: done.append(txt)
    if name == "threads": event.reply(" ".join(map(str, threading.enumerate()))) ; return
    target = kernel
    for n in name.split("."):
        try: todo = getattr(target, n)
        except AttributeError: break
        target = todo
    if not todo: return
    try: event.reply(" ".join(todo.keys()))
    except AttributeError: event.reply(str(todo))

kernel.cmnds.register("ls", do_list)
